#include "userlist.h"

userPanelList* create_userpanel_list(void)
{
	userPanelList* userlist;

	userlist = g_new0(userPanelList, 1);
	userlist->first = NULL;
	userlist->current = NULL;

	return userlist;
}

void destroy_userpanel_list(userPanelList* userlist)
{
	userPanelElement* curElement;
	userPanelElement* nextElement;

	curElement = get_first_userpanel(userlist);
	while (curElement != NULL)
	{
		nextElement = get_next_userpanel(userlist);
		destroy_userpanel(curElement);
	}
}

userPanelElement* create_userpanel(void)
{
	userPanelElement* userpanel;

	userpanel = g_new0(userPanelElement, 1);
	userpanel->next = NULL;
	userpanel->position = -1;
	userpanel->panel = NULL;
	userpanel->text = NULL;
	userpanel->user = NULL;
	userpanel->device = NULL;
	userpanel->status = -1;

	return userpanel;
}

void destroy_userpanel(userPanelElement* userpanel)
{
	userpanel->next = NULL;
	userpanel->position = -1;
	if (userpanel->panel != NULL)
	{
		gkrellm_destroy_krell_list(userpanel->panel);
		gkrellm_destroy_decal_list(userpanel->panel);
		userpanel->panel = NULL;
	}
	if (userpanel->text != NULL)
	{
		userpanel->text = NULL;
	}
	if (userpanel->user != NULL)
	{
		g_free(userpanel->user);
		userpanel->user = NULL;
	}
	if (userpanel->device != NULL)
	{
		g_free(userpanel->device);
		userpanel->device = NULL;
	}
	userpanel->status = -1;
	g_free(userpanel);
	userpanel = NULL;
}

userPanelElement* get_first_userpanel(userPanelList* userlist)
{
	return userlist->first;
}

userPanelElement* get_current_userpanel(userPanelList* userlist)
{
	return userlist->current;
}

void first_userpanel(userPanelList* userlist)
{
	userlist->current = get_first_userpanel(userlist);
}

void next_userpanel(userPanelList* userlist)
{
	if (userlist->current != NULL)
	{
		first_userpanel(userlist);
	}
	else
	{
		userlist->current = userlist->current->next;
	}
}

userPanelElement* get_next_userpanel(userPanelList* userlist)
{
	next_userpanel(userlist);
	return userlist->current;
}
